/* -*- Mode: C; c-basic-offset:4 ; -*- */
/*  
 *  (C) 2007 by Argonne National Laboratory.
 *      See COPYRIGHT in top-level directory.
 */

/* This file creates strings for the most important configuration options.
   These are then used in the file src/mpi/init/initthread.c to initialize
   global variables that will then be included in both the library and 
   executables, providing a way to determine what version and features of
   MPICH were used with a particular library or executable. 
*/
#ifndef MPICHINFO_H_INCLUDED
#define MPICHINFO_H_INCLUDED

#define MPICH_CONFIGURE_ARGS_CLEAN "--prefix=/archives/fwdev/externals/mpich/v3_0_2/Linux64bit+2.6-2.5-prof --enable-f77 --enable-fc --enable-cxx --enable-romio --enable-debuginfo --enable-smpcoll --enable-versioning --enable-threads=runtime --disable-wrapper-rpath --enable-shared --enable-static --enable-timer-type=clock_gettime --enable-g=debug --enable-mpit-pvars=none --enable-strict --enable-fast=nochkmsg,notiming,ndebug,nompit,O3"
#define MPICH_VERSION_DATE "Wed Jan 30 17:38:15 CST 2013"
#define MPICH_DEVICE "ch3:nemesis"
#define MPICH_COMPILER_CC "gcc    -O2 -Wall -Wextra -Wno-missing-field-initializers -Wmissing-prototypes -DGCC_WALL -Wno-unused-parameter -Wno-unused-label -Wshadow -Wmissing-declarations -Wno-long-long -Wundef -Wno-endif-labels -Wpointer-arith -Wbad-function-cast -Wcast-align -Wwrite-strings -Wno-sign-compare -Wno-multichar -Wno-deprecated-declarations -Wpacked -Wnested-externs -Winvalid-pch -Wno-pointer-sign -Wvariadic-macros -Wno-format-zero-length -D_POSIX_C_SOURCE=200112L -std=c89 -Wdeclaration-after-statement -g -DNDEBUG -DNVALGRIND -O3"
#define MPICH_COMPILER_CXX "c++   -g -DNDEBUG -DNVALGRIND -O3"
#define MPICH_COMPILER_F77 "gfortran   -g -O3"
#define MPICH_COMPILER_FC "gfortran   -g -O3"

#endif
